JUCE: CharPointer_ASCII Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
CharPointer_ASCII Class Referencefinal
juce_core » text

Wraps a pointer to a null-terminated ASCII character string, and provides various methods to operate on the data. More...

`#include <juce_CharPointer_ASCII.h>`

## Public Types
using | CharType = char

## Public Member Functions
| CharPointer_ASCII (const CharType *rawPointer) noexcept
| CharPointer_ASCII (const CharPointer_ASCII &other)=default
CharPointer_ASCII | operator= (const CharPointer_ASCII other) noexcept
CharPointer_ASCII | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_ASCII other) const noexcept
| This is a pointer comparison, it doesn't compare the actual text.
bool | operator!= (CharPointer_ASCII other) const noexcept
bool | operator<= (CharPointer_ASCII other) const noexcept
bool | operator< (CharPointer_ASCII other) const noexcept
bool | operator>= (CharPointer_ASCII other) const noexcept
bool | operator> (CharPointer_ASCII other) const noexcept
CharType * | getAddress () const noexcept
| Returns the address that this pointer is pointing to.
| operator const CharType * () const noexcept
| Returns the address that this pointer is pointing to.
bool | isEmpty () const noexcept
| Returns true if this pointer is pointing to a null character.
bool | isNotEmpty () const noexcept
| Returns true if this pointer is not pointing to a null character.
juce_wchar | operator* () const noexcept
| Returns the unicode character that this pointer is pointing to.
CharPointer_ASCII | operator++ () noexcept
| Moves this pointer along to the next character in the string.
CharPointer_ASCII | operator-- () noexcept
| Moves this pointer to the previous character in the string.
juce_wchar | getAndAdvance () noexcept
| Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.
CharPointer_ASCII | operator++ (int) noexcept
| Moves this pointer along to the next character in the string.
void | operator+= (const int numToSkip) noexcept
| Moves this pointer forwards by the specified number of characters.
void | operator-= (const int numToSkip) noexcept
juce_wchar | operator[] (const int characterIndex) const noexcept
| Returns the character at a given character index from the start of the string.
CharPointer_ASCII | operator+ (const int numToSkip) const noexcept
| Returns a pointer which is moved forwards from this one by the specified number of characters.
CharPointer_ASCII | operator- (const int numToSkip) const noexcept
| Returns a pointer which is moved backwards from this one by the specified number of characters.
void | write (const juce_wchar charToWrite) noexcept
| Writes a unicode character to this string, and advances this pointer to point to the next position.
void | replaceChar (const juce_wchar newChar) noexcept
void | writeNull () const noexcept
| Writes a null character to this string (leaving the pointer's position unchanged).
size_t | length () const noexcept
| Returns the number of characters in this string.
size_t | lengthUpTo (const size_t maxCharsToCount) const noexcept
| Returns the number of characters in this string, or the given value, whichever is lower.
size_t | lengthUpTo (const CharPointer_ASCII end) const noexcept
| Returns the number of characters in this string, or up to the given end pointer, whichever is lower.
size_t | sizeInBytes () const noexcept
| Returns the number of bytes that are used to represent this string.
CharPointer_ASCII | findTerminatingNull () const noexcept
| Returns a pointer to the null character that terminates this string.
template<typename CharPointer >
void | writeAll (const CharPointer src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
size_t | writeWithDestByteLimit (const CharPointer src, const size_t maxDestBytes) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
void | writeWithCharLimit (const CharPointer src, const int maxChars) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
int | compare (const CharPointer other) const noexcept
| Compares this string with another one.
int | compare (const CharPointer_ASCII other) const noexcept
| Compares this string with another one.
template<typename CharPointer >
int | compareUpTo (const CharPointer other, const int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
int | compareUpTo (const CharPointer_ASCII other, const int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer >
int | compareIgnoreCase (const CharPointer other) const
| Compares this string with another one.
int | compareIgnoreCase (const CharPointer_ASCII other) const
template<typename CharPointer >
int | compareIgnoreCaseUpTo (const CharPointer other, const int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer >
int | indexOf (const CharPointer stringToFind) const noexcept
| Returns the character index of a substring, or -1 if it isn't found.
int | indexOf (const juce_wchar charToFind) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
int | indexOf (const juce_wchar charToFind, const bool ignoreCase) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
bool | isWhitespace () const
| Returns true if the first character of this string is whitespace.
bool | isDigit () const
| Returns true if the first character of this string is a digit.
bool | isLetter () const
| Returns true if the first character of this string is a letter.
bool | isLetterOrDigit () const
| Returns true if the first character of this string is a letter or digit.
bool | isUpperCase () const
| Returns true if the first character of this string is upper-case.
bool | isLowerCase () const
| Returns true if the first character of this string is lower-case.
juce_wchar | toUpperCase () const noexcept
| Returns an upper-case version of the first character of this string.
juce_wchar | toLowerCase () const noexcept
| Returns a lower-case version of the first character of this string.
int | getIntValue32 () const noexcept
| Parses this string as a 32-bit integer.
int64 | getIntValue64 () const noexcept
| Parses this string as a 64-bit integer.
double | getDoubleValue () const noexcept
| Parses this string as a floating point double.
CharPointer_ASCII | findEndOfWhitespace () const noexcept
| Returns the first non-whitespace character in the string.
void | incrementToEndOfWhitespace () noexcept
| Move this pointer to the first non-whitespace character in the string.

## Static Public Member Functions
static size_t | getBytesRequiredFor (const juce_wchar) noexcept
| Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.
template<class CharPointer >
static size_t | getBytesRequiredFor (const CharPointer text) noexcept
| Returns the number of bytes that would be needed to represent the given string in this encoding format.
static bool | canRepresent (juce_wchar character) noexcept
| Returns true if the given unicode character can be represented in this encoding.
static bool | isValidString (const CharType *dataToTest, int maxBytesToRead)
| Returns true if this data contains a valid string in this encoding.

## Detailed Description

Wraps a pointer to a null-terminated ASCII character string, and provides various methods to operate on the data.

A valid ASCII string is assumed to not contain any characters above 127.

See also
  CharPointer_UTF8, CharPointer_UTF16, CharPointer_UTF32

## Member Typedef Documentation

## ◆ CharType

using CharPointer_ASCII::CharType = char

## Constructor & Destructor Documentation

## ◆ CharPointer_ASCII() [1/2]

CharPointer_ASCII::CharPointer_ASCII | ( | const CharType * | rawPointer | ) |
| explicitnoexcept

Referenced by findTerminatingNull(), operator+(), and operator-().

## ◆ CharPointer_ASCII() [2/2]

CharPointer_ASCII::CharPointer_ASCII | ( | const CharPointer_ASCII & | other | ) |
| default

## Member Function Documentation

## ◆ operator=() [1/2]

CharPointer_ASCII CharPointer_ASCII::operator= | ( | const CharPointer_ASCII | other | ) |
| noexcept

## ◆ operator=() [2/2]

CharPointer_ASCII CharPointer_ASCII::operator= | ( | const CharType * | text | ) |
| noexcept

## ◆ operator==()

bool CharPointer_ASCII::operator== | ( | CharPointer_ASCII | other | ) | const
| noexcept

This is a pointer comparison, it doesn't compare the actual text.

## ◆ operator!=()

bool CharPointer_ASCII::operator!= | ( | CharPointer_ASCII | other | ) | const
| noexcept

## ◆ operator<=()

bool CharPointer_ASCII::operator<= | ( | CharPointer_ASCII | other | ) | const
| noexcept

## ◆ operator<()

bool CharPointer_ASCII::operator< | ( | CharPointer_ASCII | other | ) | const
| noexcept

## ◆ operator>=()

bool CharPointer_ASCII::operator>= | ( | CharPointer_ASCII | other | ) | const
| noexcept

## ◆ operator>()

bool CharPointer_ASCII::operator> | ( | CharPointer_ASCII | other | ) | const
| noexcept

## ◆ getAddress()

CharType * CharPointer_ASCII::getAddress | ( |  | ) | const
| noexcept

Returns the address that this pointer is pointing to.

## ◆ operator const CharType *()

CharPointer_ASCII::operator const CharType * | ( |  | ) | const
| noexcept

Returns the address that this pointer is pointing to.

## ◆ isEmpty()

bool CharPointer_ASCII::isEmpty | ( |  | ) | const
| noexcept

Returns true if this pointer is pointing to a null character.

## ◆ isNotEmpty()

bool CharPointer_ASCII::isNotEmpty | ( |  | ) | const
| noexcept

Returns true if this pointer is not pointing to a null character.

## ◆ operator*()

juce_wchar CharPointer_ASCII::operator* | ( |  | ) | const
| noexcept

Returns the unicode character that this pointer is pointing to.

## ◆ operator++() [1/2]

CharPointer_ASCII CharPointer_ASCII::operator++ | ( |  | ) |
| noexcept

Moves this pointer along to the next character in the string.

## ◆ operator--()

CharPointer_ASCII CharPointer_ASCII::operator-- | ( |  | ) |
| noexcept

Moves this pointer to the previous character in the string.

## ◆ getAndAdvance()

juce_wchar CharPointer_ASCII::getAndAdvance | ( |  | ) |
| noexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

## ◆ operator++() [2/2]

CharPointer_ASCII CharPointer_ASCII::operator++ | ( | int |  | ) |
| noexcept

Moves this pointer along to the next character in the string.

## ◆ operator+=()

void CharPointer_ASCII::operator+= | ( | const int | numToSkip | ) |
| noexcept

Moves this pointer forwards by the specified number of characters.

## ◆ operator-=()

void CharPointer_ASCII::operator-= | ( | const int | numToSkip | ) |
| noexcept

## ◆ operator[]()

juce_wchar CharPointer_ASCII::operator[] | ( | const int | characterIndex | ) | const
| noexcept

Returns the character at a given character index from the start of the string.

## ◆ operator+()

CharPointer_ASCII CharPointer_ASCII::operator+ | ( | const int | numToSkip | ) | const
| noexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

References CharPointer_ASCII().

## ◆ operator-()

CharPointer_ASCII CharPointer_ASCII::operator- | ( | const int | numToSkip | ) | const
| noexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

References CharPointer_ASCII().

## ◆ write()

void CharPointer_ASCII::write | ( | const juce_wchar | charToWrite | ) |
| noexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

## ◆ replaceChar()

void CharPointer_ASCII::replaceChar | ( | const juce_wchar | newChar | ) |
| noexcept

## ◆ writeNull()

void CharPointer_ASCII::writeNull | ( |  | ) | const
| noexcept

Writes a null character to this string (leaving the pointer's position unchanged).

## ◆ length()

size_t CharPointer_ASCII::length | ( |  | ) | const
| noexcept

Returns the number of characters in this string.

Referenced by findTerminatingNull(), and sizeInBytes().

## ◆ lengthUpTo() [1/2]

size_t CharPointer_ASCII::lengthUpTo | ( | const size_t | maxCharsToCount | ) | const
| noexcept

Returns the number of characters in this string, or the given value, whichever is lower.

References CharacterFunctions::lengthUpTo().

## ◆ lengthUpTo() [2/2]

size_t CharPointer_ASCII::lengthUpTo | ( | const CharPointer_ASCII | end | ) | const
| noexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

References end(), and CharacterFunctions::lengthUpTo().

## ◆ sizeInBytes()

size_t CharPointer_ASCII::sizeInBytes | ( |  | ) | const
| noexcept

Returns the number of bytes that are used to represent this string.

This includes the terminating null character.

References length().

## ◆ getBytesRequiredFor() [1/2]

static size_t CharPointer_ASCII::getBytesRequiredFor | ( | const juce_wchar |  | ) |
| staticnoexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

## ◆ getBytesRequiredFor() [2/2]

template<class CharPointer >

static size_t CharPointer_ASCII::getBytesRequiredFor | ( | const CharPointer | text | ) |
| staticnoexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format.

The value returned does NOT include the terminating null character.

## ◆ findTerminatingNull()

CharPointer_ASCII CharPointer_ASCII::findTerminatingNull | ( |  | ) | const
| noexcept

Returns a pointer to the null character that terminates this string.

References CharPointer_ASCII(), and length().

## ◆ writeAll()

template<typename CharPointer >

void CharPointer_ASCII::writeAll | ( | const CharPointer | src | ) |
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References CharacterFunctions::copyAll().

## ◆ writeWithDestByteLimit()

template<typename CharPointer >

size_t CharPointer_ASCII::writeWithDestByteLimit | ( | const CharPointer | src,
|  | const size_t | maxDestBytes )
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

References CharacterFunctions::copyWithDestByteLimit().

## ◆ writeWithCharLimit()

template<typename CharPointer >

void CharPointer_ASCII::writeWithCharLimit | ( | const CharPointer | src,
|  | const int | maxChars )
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

References CharacterFunctions::copyWithCharLimit().

## ◆ compare() [1/2]

template<typename CharPointer >

int CharPointer_ASCII::compare | ( | const CharPointer | other | ) | const
| noexcept

Compares this string with another one.

References CharacterFunctions::compare().

## ◆ compare() [2/2]

int CharPointer_ASCII::compare | ( | const CharPointer_ASCII | other | ) | const
| noexcept

Compares this string with another one.

## ◆ compareUpTo() [1/2]

template<typename CharPointer >

int CharPointer_ASCII::compareUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const
| noexcept

Compares this string with another one, up to a specified number of characters.

References CharacterFunctions::compareUpTo().

## ◆ compareUpTo() [2/2]

int CharPointer_ASCII::compareUpTo | ( | const CharPointer_ASCII | other,
|  | const int | maxChars ) const
| noexcept

Compares this string with another one, up to a specified number of characters.

## ◆ compareIgnoreCase() [1/2]

template<typename CharPointer >

int CharPointer_ASCII::compareIgnoreCase | ( | const CharPointer | other | ) | const

Compares this string with another one.

References CharacterFunctions::compareIgnoreCase().

## ◆ compareIgnoreCase() [2/2]

int CharPointer_ASCII::compareIgnoreCase | ( | const CharPointer_ASCII | other | ) | const

References CharacterFunctions::compareIgnoreCase().

## ◆ compareIgnoreCaseUpTo()

template<typename CharPointer >

int CharPointer_ASCII::compareIgnoreCaseUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const
| noexcept

Compares this string with another one, up to a specified number of characters.

References CharacterFunctions::compareIgnoreCaseUpTo().

## ◆ indexOf() [1/3]

template<typename CharPointer >

int CharPointer_ASCII::indexOf | ( | const CharPointer | stringToFind | ) | const
| noexcept

Returns the character index of a substring, or -1 if it isn't found.

References CharacterFunctions::indexOf().

## ◆ indexOf() [2/3]

int CharPointer_ASCII::indexOf | ( | const juce_wchar | charToFind | ) | const
| noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

## ◆ indexOf() [3/3]

int CharPointer_ASCII::indexOf | ( | const juce_wchar | charToFind,
|  | const bool | ignoreCase ) const
| noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References CharacterFunctions::indexOfChar(), and CharacterFunctions::indexOfCharIgnoreCase().

## ◆ isWhitespace()

bool CharPointer_ASCII::isWhitespace | ( |  | ) | const

Returns true if the first character of this string is whitespace.

References CharacterFunctions::isWhitespace().

## ◆ isDigit()

bool CharPointer_ASCII::isDigit | ( |  | ) | const

Returns true if the first character of this string is a digit.

References CharacterFunctions::isDigit().

## ◆ isLetter()

bool CharPointer_ASCII::isLetter | ( |  | ) | const

Returns true if the first character of this string is a letter.

References CharacterFunctions::isLetter().

## ◆ isLetterOrDigit()

bool CharPointer_ASCII::isLetterOrDigit | ( |  | ) | const

Returns true if the first character of this string is a letter or digit.

References CharacterFunctions::isLetterOrDigit().

## ◆ isUpperCase()

bool CharPointer_ASCII::isUpperCase | ( |  | ) | const

Returns true if the first character of this string is upper-case.

References CharacterFunctions::isUpperCase().

## ◆ isLowerCase()

bool CharPointer_ASCII::isLowerCase | ( |  | ) | const

Returns true if the first character of this string is lower-case.

References CharacterFunctions::isLowerCase().

## ◆ toUpperCase()

juce_wchar CharPointer_ASCII::toUpperCase | ( |  | ) | const
| noexcept

Returns an upper-case version of the first character of this string.

References CharacterFunctions::toUpperCase().

## ◆ toLowerCase()

juce_wchar CharPointer_ASCII::toLowerCase | ( |  | ) | const
| noexcept

Returns a lower-case version of the first character of this string.

References CharacterFunctions::toLowerCase().

## ◆ getIntValue32()

int CharPointer_ASCII::getIntValue32 | ( |  | ) | const
| noexcept

Parses this string as a 32-bit integer.

## ◆ getIntValue64()

int64 CharPointer_ASCII::getIntValue64 | ( |  | ) | const
| noexcept

Parses this string as a 64-bit integer.

## ◆ getDoubleValue()

double CharPointer_ASCII::getDoubleValue | ( |  | ) | const
| noexcept

Parses this string as a floating point double.

References CharacterFunctions::getDoubleValue().

## ◆ findEndOfWhitespace()

CharPointer_ASCII CharPointer_ASCII::findEndOfWhitespace | ( |  | ) | const
| noexcept

Returns the first non-whitespace character in the string.

References CharacterFunctions::findEndOfWhitespace().

## ◆ incrementToEndOfWhitespace()

void CharPointer_ASCII::incrementToEndOfWhitespace | ( |  | ) |
| noexcept

Move this pointer to the first non-whitespace character in the string.

References CharacterFunctions::incrementToEndOfWhitespace().

## ◆ canRepresent()

static bool CharPointer_ASCII::canRepresent | ( | juce_wchar | character | ) |
| staticnoexcept

Returns true if the given unicode character can be represented in this encoding.

## ◆ isValidString()

static bool CharPointer_ASCII::isValidString | ( | const CharType * | dataToTest,
|  | int | maxBytesToRead )
| static

Returns true if this data contains a valid string in this encoding.

The documentation for this class was generated from the following file:

- juce_CharPointer_ASCII.h